'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getEjectableName = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(stack) {
    var choices, answers;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            choices = stack.ejectables.entries().map(function (_ref2) {
              var _ref3 = (0, _slicedToArray3.default)(_ref2, 2),
                  name = _ref3[0],
                  ejectable = _ref3[1];

              return { value: name, name: ejectable.label };
            });

            if (choices.length) {
              _context.next = 3;
              break;
            }

            throw new Error('This project has no ejectables.');

          case 3:
            _context.next = 5;
            return _inquirer2.default.prompt({
              type: 'list',
              name: 'path',
              message: 'Select file',
              choices: choices
            });

          case 5:
            answers = _context.sent;
            return _context.abrupt('return', answers.path);

          case 7:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getEjectableName(_x) {
    return _ref.apply(this, arguments);
  };
}();

var handle = function () {
  var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(args, options, logger) {
    var manager, file;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _utils.getStackManager)();

          case 2:
            manager = _context2.sent;
            _context2.t0 = args.file;

            if (_context2.t0) {
              _context2.next = 8;
              break;
            }

            _context2.next = 7;
            return getEjectableName(manager.stack);

          case 7:
            _context2.t0 = _context2.sent;

          case 8:
            file = _context2.t0;
            _context2.next = 11;
            return manager.eject(file);

          case 11:

            logger.info('Done.');

          case 12:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function handle(_x2, _x3, _x4) {
    return _ref4.apply(this, arguments);
  };
}();

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function register(program) {
  program.command('eject', 'Eject file').argument('[file]', 'Ejectable name').action((0, _utils.catchErrors)(handle));
}

exports.default = { register: register };