'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getStackName = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var answers;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _inquirer2.default.prompt({
              type: 'list',
              name: 'stack',
              message: 'Select the stack',
              choices: [{ value: 'wordpress', name: 'Wordpress' }, { value: 'laravel', name: 'Laravel' }]
            });

          case 2:
            answers = _context.sent;
            return _context.abrupt('return', answers.stack);

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getStackName() {
    return _ref.apply(this, arguments);
  };
}();

var getOptions = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(stack) {
    var wizard, questions, answers;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            wizard = getWizard(stack);

            if (wizard) {
              _context2.next = 3;
              break;
            }

            return _context2.abrupt('return', {});

          case 3:
            questions = wizard.getQuestions();
            _context2.next = 6;
            return _inquirer2.default.prompt(questions);

          case 6:
            answers = _context2.sent;
            return _context2.abrupt('return', wizard.makeOptions(answers));

          case 8:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function getOptions(_x) {
    return _ref2.apply(this, arguments);
  };
}();

var handle = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(args, options, logger) {
    var config;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return (0, _utils.getStackConfig)();

          case 2:
            if (!_context3.sent) {
              _context3.next = 4;
              break;
            }

            throw new Error('The project is already initialized');

          case 4:
            config = new _stackerCore.StackConfig();
            _context3.t0 = args.stack;

            if (_context3.t0) {
              _context3.next = 10;
              break;
            }

            _context3.next = 9;
            return getStackName();

          case 9:
            _context3.t0 = _context3.sent;

          case 10:
            config.stack = _context3.t0;

            if (!options.defaults) {
              _context3.next = 15;
              break;
            }

            _context3.t1 = null;
            _context3.next = 18;
            break;

          case 15:
            _context3.next = 17;
            return getOptions(config.stack);

          case 17:
            _context3.t1 = _context3.sent;

          case 18:
            config.options = _context3.t1;
            _context3.next = 21;
            return config.save(process.cwd());

          case 21:

            logger.info('Done.');

          case 22:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function handle(_x2, _x3, _x4) {
    return _ref3.apply(this, arguments);
  };
}();

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _stackerCore = require('stacker-core');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getWizard(stack) {
  if (stack === 'wordpress') return _stackerCore.WordpressWizard;
  if (stack === 'laravel') return _stackerCore.LaravelWizard;
}

function register(program) {
  program.command('init', 'Init project').argument('[stack]', 'Stack type', ['laravel']).option('-y, --defaults', 'Use default options', program.BOOL, false).action((0, _utils.catchErrors)(handle));
}

exports.default = { register: register };