'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var handle = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(args, options, logger) {
    var projectPath, link, answers, data, _link;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            projectPath = process.cwd();
            _context.next = 3;
            return _stackerCore.Links.find({ projectPath: projectPath });

          case 3:
            link = _context.sent;

            if (!(link !== null)) {
              _context.next = 8;
              break;
            }

            logger.info('This project is already linked.');
            _context.next = 16;
            break;

          case 8:
            _context.next = 10;
            return promptProjectName();

          case 10:
            answers = _context.sent;
            data = {
              name: answers.name,
              host: answers.host,
              projectPath: projectPath
            };
            _context.next = 14;
            return _stackerCore.Links.create(data);

          case 14:
            _link = _context.sent;


            logger.info('The project was linked.', _link);

          case 16:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function handle(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _stackerCore = require('stacker-core');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function promptProjectName() {
  return _inquirer2.default.prompt([{
    type: 'input',
    name: 'name',
    message: 'Project Name',
    default: (0, _stackerCore.titleCase)(_path2.default.basename(process.cwd()))
  }, {
    type: 'input',
    name: 'host',
    message: 'Hostname',
    default: _path2.default.basename(process.cwd()) + '.dev'
  }]);
}

function register(program) {
  program.command('link', 'Link project').action((0, _utils.catchErrors)(handle));
}

exports.default = { register: register };