'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getServiceName = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(stack) {
    var choices, answers;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            choices = stack.services.values().filter(function (service) {
              return service.shell;
            }).map(function (service) {
              return service.name;
            });
            _context.next = 3;
            return _inquirer2.default.prompt({
              type: 'list',
              name: 'service',
              message: 'Select service',
              choices: choices
            });

          case 3:
            answers = _context.sent;
            return _context.abrupt('return', answers.service);

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getServiceName(_x) {
    return _ref.apply(this, arguments);
  };
}();

var handle = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(args) {
    var manager, service;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _utils.getStackManager)();

          case 2:
            manager = _context2.sent;
            _context2.t0 = args.service;

            if (_context2.t0) {
              _context2.next = 8;
              break;
            }

            _context2.next = 7;
            return getServiceName(manager.stack);

          case 7:
            _context2.t0 = _context2.sent;

          case 8:
            service = _context2.t0;
            return _context2.abrupt('return', manager.shell(service));

          case 10:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function handle(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function register(program) {
  program.command('shell', 'Open shell').alias('sh').argument('[service]', 'Service name').action((0, _utils.catchErrors)(handle));
}

exports.default = { register: register };