'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var handle = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(args, options, logger) {
    var projectPath, link, answers;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            projectPath = process.cwd();
            _context.next = 3;
            return _stackerCore.Links.find({ projectPath: projectPath });

          case 3:
            link = _context.sent;

            if (!(link === null)) {
              _context.next = 8;
              break;
            }

            logger.info('The project is not linked at all.');
            _context.next = 15;
            break;

          case 8:
            _context.next = 10;
            return confirmUnlink();

          case 10:
            answers = _context.sent;

            if (!answers.confirmed) {
              _context.next = 15;
              break;
            }

            _context.next = 14;
            return _stackerCore.Links.remove(link._id);

          case 14:
            logger.info('The project was unlinked.');

          case 15:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function handle(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _stackerCore = require('stacker-core');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function confirmUnlink() {
  return _inquirer2.default.prompt({
    type: 'confirm',
    name: 'confirmed',
    message: 'Are you sure?'
  });
}

function register(program) {
  program.command('unlink', 'Unlink project').action((0, _utils.catchErrors)(handle));
}

exports.default = { register: register };