'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getStackManager = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getStackManager = exports.getStackManager = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var path = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : process.cwd();
    var config;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return getStackConfig(path);

          case 2:
            config = _context.sent;

            if (config) {
              _context.next = 5;
              break;
            }

            throw new Error('This project is not initialized yet. Run "stacker init".');

          case 5:
            return _context.abrupt('return', new _stackerCore.StackManager(config));

          case 6:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getStackManager() {
    return _ref.apply(this, arguments);
  };
}();

exports.getStackConfig = getStackConfig;
exports.catchErrors = catchErrors;

var _stackerCore = require('stacker-core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getStackConfig() {
  var path = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : process.cwd();

  return _stackerCore.StackConfig.loadRecursive(path);
}

function catchErrors(handle) {
  return function () {
    var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(args, options, logger) {
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              _context2.next = 3;
              return handle(args, options, logger);

            case 3:
              _context2.next = 8;
              break;

            case 5:
              _context2.prev = 5;
              _context2.t0 = _context2['catch'](0);

              logger.error(_context2.t0.message);

            case 8:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this, [[0, 5]]);
    }));

    return function (_x3, _x4, _x5) {
      return _ref2.apply(this, arguments);
    };
  }();
}